//---------------------------------------------------------------------------
#ifndef TGameBoxH
#define TGameBoxH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TGameTimer;
class TGameField;
class TGamePad;
class TGameSound;
//---------------------------------------------------------------------------
struct TGameBoxOptions
{
	int HighScore;
	bool BusyGame;
	bool Sound;

	__fastcall TGameBoxOptions();
	__fastcall virtual ~TGameBoxOptions();

	bool __fastcall operator==(const TGameBoxOptions& ASrc) const;
	bool __fastcall operator!=(const TGameBoxOptions& ASrc) const;
};
//---------------------------------------------------------------------------
class TGameBox : public TPaintBox
{
private:
	enum MODE {MODE_NONE, MODE_TITLE, MODE_NEW1P, MODE_NEW2P, MODE_GAMEOVER, MODE_QUIT} FMode;
	TGameTimer* FTimer;
	TGameField* FField;
	TGamePad** FPads;
	TGameSound* FSound;
	Graphics::TBitmap* FBitmap;
	TImageList* FImages;
	TNotifyEvent FOnChange;

	void __fastcall SetMode(MODE AMode);
	TGameBoxOptions __fastcall GetOptions();
	void __fastcall SetImages(TImageList* AImages);
	void __fastcall SetOptions(TGameBoxOptions AOptions);
	int __fastcall GetOriginalWidth();
	int __fastcall GetOriginalHeight();
	void __fastcall TimerTimer(TObject *Sender);
	void __fastcall DrawTitle(TCanvas* ACanvas);

	__property MODE Mode = {read=FMode, write=SetMode};

protected:
	void __fastcall DoChange();
	void __fastcall Paint();

public:
	__fastcall TGameBox(TComponent* AOwner);
	__fastcall virtual ~TGameBox();

	void __fastcall Title();
	void __fastcall New(int APlayerCount);
	void __fastcall Quit();
	void __fastcall KeyDown(int AKey);
	void __fastcall KeyUp(int AKey);

	__property TImageList* Images = {read=FImages, write=SetImages};
	__property TGameBoxOptions Options = {read=GetOptions, write=SetOptions};
	__property int OriginalWidth = {read=GetOriginalWidth};
	__property int OriginalHeight = {read=GetOriginalHeight};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
#endif

