//---------------------------------------------------------------------------
#ifndef TGameFieldH
#define TGameFieldH
//---------------------------------------------------------------------------
#include <vector>
#include <Classes.hpp>
//#include "TGameUnit.h"
//---------------------------------------------------------------------------
class TGameMap;
class TGameUnit;
class TGamePlayerUnit;
class TGamePad;
class TGameSound;
//---------------------------------------------------------------------------
class TGameField
{
private:
	std::vector<TGameUnit*> FUnits;
	std::vector<TGamePlayerUnit*> FPlayerUnits;
	TGameMap* FMap;

	int FHighScore;
	bool FBusyGame;
	bool FGameOver;
	AnsiString FStatus;

	void __fastcall Clear();

public:
	__fastcall TGameField(int AWidth, int AHeight);
	__fastcall virtual ~TGameField();

	void __fastcall RegisterUnit(TGameUnit* AUnit);

	void __fastcall Prepare(int APlayerCount);
	void __fastcall Move(TGamePad** APads, TGameSound* ASound);
	void __fastcall Draw(TCanvas* ACanvas, TImageList* AImages);

	__property TGameMap* Map = {read=FMap};
	__property int HighScore = {read=FHighScore, write=FHighScore};
	__property bool BusyGame = {read=FBusyGame, write=FBusyGame};
	__property bool GameOver = {read=FGameOver};
	__property AnsiString Status = {read=FStatus, write=FStatus};
};
//---------------------------------------------------------------------------
#endif

