//---------------------------------------------------------------------------
#ifndef TGameFormH
#define TGameFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TGameBox;
//---------------------------------------------------------------------------
struct TGameFormOptions
{
	bool Sizable;
	bool LastPosition;

	__fastcall TGameFormOptions();
	__fastcall virtual ~TGameFormOptions();

	bool __fastcall operator==(const TGameFormOptions& ASrc) const;
	bool __fastcall operator!=(const TGameFormOptions& ASrc) const;
};
//---------------------------------------------------------------------------
class TGameForm : public TForm
{
__published:
	TImageList *ImageList1;
	TMainMenu *MainMenu1;
	TMenuItem *Game_MenuItem;
	TMenuItem *New1Player_MenuItem;
	TMenuItem *New2Players_MenuItem;
	TMenuItem *Status_MenuItem;
	TMenuItem *Options_MenuItem;
	TMenuItem *ClearHighScore_MenuItem;
	TMenuItem *BusyGame_MenuItem;
	TMenuItem *Sizable_MenuItem;
	TMenuItem *ResizeTo100_MenuItem;
	TMenuItem *ResizeTo150_MenuItem;
	TMenuItem *ResizeTo200_MenuItem;
	TMenuItem *LastPosition_MenuItem;
	TMenuItem *Sound_MenuItem;
	TMenuItem *Default_MenuItem;
	TMenuItem *Exit_MenuItem;
	TMenuItem *Help1_MenuItem;
	TMenuItem *Help2_MenuItem;
	TMenuItem *Tips_MenuItem;
	TMenuItem *About_MenuItem;
	TPopupMenu *PopupMenu1;
	TMenuItem *New1PlayerP_MenuItem;
	TMenuItem *New2PlayersP_MenuItem;
	TMenuItem *StatusP_MenuItem;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *N5;
	TMenuItem *N6;

	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall MenuItemClick(TObject *Sender);
	void __fastcall OptionsChange(TObject* ASender);
	void __fastcall GameBoxChange(TObject* ASender);

private:
	TGameBox* FGameBox;
	TGameFormOptions FOptions;

	void __fastcall SetOptions(TGameFormOptions AOptions);
	void __fastcall ResizeClient(int APercentage);
	void __fastcall ResizeClient(int AWidth, int AHeight);
	void __fastcall DefaultSettings();
	void __fastcall LoadSettings();
	void __fastcall SaveSettings();

public:
	__fastcall TGameForm(TComponent* Owner);
	__fastcall virtual ~TGameForm();

	__property TGameBox* GameBox = {read=FGameBox};
	__property TGameFormOptions Options = {read=FOptions, write=SetOptions};
};
//---------------------------------------------------------------------------
extern PACKAGE TGameForm *GameForm;
//---------------------------------------------------------------------------
#endif
 
