//---------------------------------------------------------------------------
#ifndef TGameMapH
#define TGameMapH
//---------------------------------------------------------------------------
#include <vector>
#include <Classes.hpp>
#include "TGameUnit.h"
//---------------------------------------------------------------------------
class TGameMap
{
private:
	int FWidth;
	int FHeight;
	GAMEWALL** FWalls;
	TGameUnit*** FUnits;
	std::vector<TPoint> FChanges;
	bool** FChanged;

	GAMEWALL __fastcall GetWall(int AX, int AY) const;
	void __fastcall SetWall(int AX, int AY, GAMEWALL AWall);
	TGameUnit* __fastcall GetUnit(int AX, int AY) const;
	void __fastcall SetUnit(int AX, int AY, TGameUnit* AUnit);
	int __fastcall GetChangeCount() const;
	TPoint __fastcall GetChange(int AIndex) const;

public:
	__fastcall TGameMap(int AWidth, int AHeight);
	__fastcall virtual ~TGameMap();

	bool __fastcall IsEmpty(int AX, int AY) const;
	bool __fastcall CanGo(int AX, int AY) const;
	int __fastcall CountWays(int AX, int AY) const;

	void __fastcall Clear();
	void __fastcall ClearWall(int AX, int AY);
	void __fastcall ClearUnit(int AX, int AY);
	void __fastcall AddChange(int AX, int AY);
	void __fastcall ClearChanges();

	__property int Width = {read=FWidth};
	__property int Height = {read=FHeight};
	__property GAMEWALL Walls[int AX][int AY] = {read=GetWall, write=SetWall};
	__property TGameUnit* Units[int AX][int AY] = {read=GetUnit, write=SetUnit};
	__property int ChangeCount = {read=GetChangeCount};
	__property TPoint Changes[int AIneex] = {read=GetChange};
};
//---------------------------------------------------------------------------
#endif

