//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TGamePad.h"
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TGamePad
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
int __fastcall TGamePad::GetCount() const
{
	return FKeys.size();
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::SetCount(int ACount)
{
	if(ACount == Count) return;

	FKeys.resize(ACount, 0);
	FPressing.clear();
	FPressed.clear();
}
//---------------------------------------------------------------------------
int __fastcall TGamePad::GetKey(int AIndex) const
{
	return FKeys[AIndex];
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::SetKey(int AIndex, int AKey)
{
	FKeys[AIndex] = AKey;
}
//---------------------------------------------------------------------------
int __fastcall TGamePad::Find(const vector<int>& AVector, int AValue) const
{
	for(unsigned int i = 0; i < AVector.size(); i++)
		if(AVector[i] == AValue) return static_cast<int>(i);

	return -1;
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::Erase(vector<int>& AVector, int AValue) const
{
	int index = Find(AVector, AValue);
	if(index >= 0)
		AVector.erase(AVector.begin() + index);
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TGamePad::TGamePad()
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TGamePad::~TGamePad()
{
	// do nothing
}
//---------------------------------------------------------------------------
int __fastcall TGamePad::KeyToIndex(int AKey) const
{
	for(unsigned int i = 0; i < FKeys.size(); i++)
		if(FKeys[i] == AKey) return i;

	return -1;
}
//---------------------------------------------------------------------------
int __fastcall TGamePad::IndexToKey(int AIndex) const
{
	return FKeys[AIndex];
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::KeyDown(int AKey)
{
	int index = KeyToIndex(AKey);
	if(index < 0 || IsPressing(index)) return;
	Press(index);
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::KeyUp(int AKey)
{
	int index = KeyToIndex(AKey);
	if(index < 0) return;
	Release(index);
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::Press(int AIndex)
{
	Erase(FPressing, AIndex);
	FPressing.insert(FPressing.begin(), AIndex);

	Erase(FPressed, AIndex);
	FPressed.insert(FPressed.begin(), AIndex);
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::Release(int AIndex)
{
	Erase(FPressing, AIndex);
}
//---------------------------------------------------------------------------
bool __fastcall TGamePad::IsPressing(int AIndex) const
{
	return Find(FPressing, AIndex) >= 0;
}
//---------------------------------------------------------------------------
bool __fastcall TGamePad::IsPressed(int AIndex) const
{
	return Find(FPressed, AIndex) >= 0;
}
//---------------------------------------------------------------------------
int __fastcall TGamePad::PressingOrder(int AIndex) const
{
	return AIndex < static_cast<int>(FPressing.size()) ? FPressing[AIndex] : -1;
}
//---------------------------------------------------------------------------
int __fastcall TGamePad::PressedOrder(int AIndex) const
{
	return AIndex < static_cast<int>(FPressed.size()) ? FPressed[AIndex] : -1;
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::Update()
{
	for(unsigned int i = 0; i < FKeys.size(); i++) {
		if(GetAsyncKeyState(FKeys[i]) < 0)
			KeyDown(FKeys[i]);
		else
			KeyUp(FKeys[i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TGamePad::Clear()
{
	FPressed.clear();
}
//---------------------------------------------------------------------------

