//---------------------------------------------------------------------------
#ifndef TGamePadH
#define TGamePadH
//---------------------------------------------------------------------------
#include <vector>
//---------------------------------------------------------------------------
class TGamePad
{
private:
	std::vector<int> FKeys;
	std::vector<int> FPressing;
	std::vector<int> FPressed;

	int __fastcall GetCount() const;
	void __fastcall SetCount(int ACount);
	int __fastcall GetKey(int AIndex) const;
	void __fastcall SetKey(int AIndex, int AKey);
	int __fastcall Find(const std::vector<int>& AVector, int AValue) const;
	void __fastcall Erase(std::vector<int>& AVector, int AValue) const;

public:
	__fastcall TGamePad();
	__fastcall virtual ~TGamePad();

	int __fastcall KeyToIndex(int AKey) const;
	int __fastcall IndexToKey(int AIndex) const;

	void __fastcall KeyDown(int AKey);
	void __fastcall KeyUp(int AKey);
	void __fastcall Press(int AIndex);
	void __fastcall Release(int AIndex);
	bool __fastcall IsPressing(int AIndex) const;
	bool __fastcall IsPressed(int AIndex) const;
	int __fastcall PressingOrder(int AIndex) const;
	int __fastcall PressedOrder(int AIndex) const;
	void __fastcall Update();
	void __fastcall Clear();

	__property int Count = {read=GetCount, write=SetCount};
	__property int Keys[int AIndex] = {read=GetKey, write=SetKey};
};
//---------------------------------------------------------------------------
// DESCRIPTION
// this is a virtual control pad
//---------------------------------------------------------------------------
#endif

