//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TGameSound.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TGameSound
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
int __fastcall TGameSound::GetCount() const
{
	return FWaves->Count;
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::LoadWaves(TStrings* AFileNames, TList* AWaves) const
{
	// load wave data from file
	AWaves->Count = AFileNames->Count;
	TFileStream* stream;
	for(int i = 0; i < AFileNames->Count; i++) {
		stream = NULL;
		try {
			stream = new TFileStream(AFileNames->Strings[i].c_str(),
				fmOpenRead | fmShareExclusive);
			if(stream->Size > 0) {
				AWaves->Items[i] = new byte[stream->Size];
				stream->Position = 0;
				stream->Read(static_cast<byte*>(AWaves->Items[i]), stream->Size);
			}
		}
		catch(...) {}
		delete stream;
	}
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::FreeWaves(TList* AWaves) const
{
	Stop();

	// free wave data
	for(int i = 0; i < AWaves->Count; i++)
		delete [] static_cast<byte*>(AWaves->Items[i]);
	AWaves->Clear();
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TGameSound::TGameSound() : FWaves(NULL), FEnabled(true)
{
	FWaves = new TList();
}
//---------------------------------------------------------------------------
__fastcall TGameSound::~TGameSound()
{
	FreeWaves(FWaves);

	delete FWaves;
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::LoadFromFile(TStrings* AFileNames)
{
	FreeWaves(FWaves);

	LoadWaves(AFileNames, FWaves);
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::Play(int AIndex) const
{
	if(!Enabled) return;

	PlaySound(static_cast<LPCSTR>(FWaves->Items[AIndex]), NULL,
		SND_ASYNC | SND_MEMORY | SND_NODEFAULT);
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::Stop() const
{
	PlaySound(NULL, NULL, SND_SYNC | SND_NODEFAULT);
}
//---------------------------------------------------------------------------

