//---------------------------------------------------------------------------
#ifndef TGameSoundH
#define TGameSoundH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TGameSound
{
private:
	typedef unsigned char byte;

	TList* FWaves;
	bool FEnabled;

	int __fastcall GetCount() const;
	void __fastcall LoadWaves(TStrings* AFilePaths, TList* AWaves) const;
	void __fastcall FreeWaves(TList* AWaves) const;

public:
	__fastcall TGameSound();
	__fastcall virtual ~TGameSound();

	void __fastcall LoadFromFile(TStrings* AFileNames);
	void __fastcall Play(int AIndex) const;
	void __fastcall Stop() const;

	__property int Count = {read=GetCount};
	__property bool Enabled = {read=FEnabled, write=FEnabled};
};
//---------------------------------------------------------------------------
// DESCRIPTION
// stores wave files in memory and plays them
//---------------------------------------------------------------------------
#endif

